import { AlgorithmType } from '../application/types/algorithm.types';
import { Frequency, Role } from './ad.types';
import { JourneyProps } from './value-objects/journey.value-object';

// All properties that a Match has
export interface MatchProps {
  adId: string;
  role: Role;
  frequency: Frequency;
  distance: number;
  duration: number;
  initialDistance: number;
  initialDuration: number;
  distanceDetour: number;
  durationDetour: number;
  distanceDetourPercentage: number;
  durationDetourPercentage: number;
  journeys: JourneyProps[];
}

// Properties that are needed for a Match creation
export interface CreateMatchProps {
  adId: string;
  role: Role;
  frequency: Frequency;
  distance: number;
  duration: number;
  initialDistance: number;
  initialDuration: number;
  journeys: JourneyProps[];
}

export interface DefaultMatchQueryProps {
  driver: boolean;
  passenger: boolean;
  marginDuration: number;
  strict: boolean;
  seatsProposed: number;
  seatsRequested: number;
  algorithmType?: AlgorithmType;
  remoteness?: number;
  useProportion?: boolean;
  proportion?: number;
  useAzimuth?: boolean;
  azimuthMargin?: number;
  maxDetourDistanceRatio?: number;
  maxDetourDurationRatio?: number;
}
